#include <iostream>
#include <cstdlib>
#include <ctime>
using namespace std;

// vC[\NX̒`i{NXj
class Player {
protected:
  char mark;			// gɏދL
  int number;			// I񂾎i1`9j
public:
  virtual void select() = 0;	// Iԁiz֐j
  char getMark();		// LԂ
  int getNumber();		// Ԃ
  Player(char mark);		// RXgN^
};

// [U[\NX̒`ihNXj
class User : public Player {
public:
  void select();		// I
  User(char mark);		// RXgN^
};

// Rs[^\NX̒`ihNXj
class Computer : public Player {
public:
  void select();		// I
  Computer(char mark);		// RXgN^
};

// Ֆʂ\NX̒`
class Board {
private:
  char cell[3][3];		// 3~3̘g
public:
  void show();			// Ֆʂ\
  bool setCell(Player *player);	// gɋL
  bool judge(Player *player);	// s𔻒肷
  Board();			// RXgN^
};

// vC[\NX̎iLԂj
char Player::getMark() {
  return mark;
}

// vC[\NX̎iԂj
int Player::getNumber() {
  return number;
}

// vC[\NX̎iRXgN^j
Player::Player(char mark) {
  this->mark = mark;
}

// [U[\NX̎iIԁj
void User::select() {
  int n;

  do {
    cout << mark << "̎Ił = ";
    cin >> n;
  } while (n < 1 || n > 9);
  number = n;
}

// [U[\NX̎iRXgN^j
User::User(char mark) : Player(mark) {
}

// Rs[^\NX̎iIԁj
void Computer::select() {
  number = rand() % 9 + 1;
  cout << mark << "̎Ił = " << number << "\n";
}

// Rs[^\NX̎iRXgN^j
Computer::Computer(char mark) : Player(mark) {
}

// Ֆʂ\NX̎iՖʂ\j
void Board::show() {
  cout << "\n";
  for (int v = 0; v < 3; v++) {
    cout << "+-+-+-+\n";
    for (int h = 0; h < 3; h++) {
      cout << "|" << cell[v][h];
    }
    cout << "|\n";
  }
  cout << "+-+-+-+\n";
}

// Ֆʂ\NX̎igɋLށj
bool Board::setCell(Player *player) {
  int number = player->getNumber();
  int v = (number - 1) / 3;
  int h = (number - 1) % 3;

  if (cell[v][h] >= '1' && cell[v][h] <= '9') {
    // ߂trueԂ
    cell[v][h] = player->getMark();
    return true;
  }
  else {
    // ߂ȂȂfalseԂ
    cout << "ɂ͏߂܂I\n";
    return false;
  }
}

// Ֆʂ\NX̎is𔻒肷j
bool Board::judge(Player *player) {
  // vC[ȂtrueԂ
  char mark = player->getMark();
  if (cell[0][0] == mark && cell[0][1] == mark && cell[0][2] == mark ||
    cell[1][0] == mark && cell[1][1] == mark && cell[1][2] == mark ||
    cell[2][0] == mark && cell[2][1] == mark && cell[2][2] == mark ||
    cell[0][0] == mark && cell[1][0] == mark && cell[2][0] == mark ||
    cell[0][1] == mark && cell[1][1] == mark && cell[2][1] == mark ||
    cell[0][2] == mark && cell[1][2] == mark && cell[2][2] == mark ||
    cell[0][0] == mark && cell[1][1] == mark && cell[2][2] == mark ||
    cell[2][0] == mark && cell[1][1] == mark && cell[0][2] == mark) {
    cout << "\nQ[IF" << mark << "̏łI\n";
    return true;
  }

  // ȂtrueԂ
  bool draw = true;
  for (int v = 0; v < 3 && draw; v++) {
    for (int h = 0; h < 3 && draw; h++) {
      if (cell[v][h] >= '1' && cell[v][h] <= '9') {
        draw = false;
      }
    }
  }
  if (draw) {
    cout << "\nQ[IF" << "łI\n";
    return true;
  }

  // sm肵ĂȂfalseԂ
  return false;
}

// Ֆʂ\NX̎iRXgN^j
Board::Board() {
  for (int v = 0; v < 3; v++) {
    for (int h = 0; h < 3; h++) {
      cell[v][h] = (v * 3 + h + 1) + '0';
    }
  }
}

// C֐
int main() {
  Player *player[2];		// 2l̃vC[i{NX̔zj
  User user('o');		// [U[iLoj
  Computer computer('x');	// Rs[^iLxj
  player[0] = &computer;	// ̃vC[iRs[^j
  player[1] = &user;		// ̃vC[i[U[j
  Board board;			// Ֆ
  int turn = 0;			// ԁi01Ō݂ɐ؂ւj

  // 
  srand(time(NULL));

  // s܂܂ŌJԂ
  while (true) {
    // Ֆʂ\
    board.show();

    // vC[I
    do {
      player[turn]->select();
    } while (board.setCell(player[turn]) == false);

    // s𔻒肷
    if (board.judge(player[turn])) {
      // sm肵Q[I
      break;
    }

    // vC[݂ɐ؂ւ
    if (turn == 0) {
      turn = 1;
    }
    else {
      turn = 0;
    }
  }

  // Ֆʂ\
  board.show();

  return 0;
}
